Subject: Re: mmotm 2019-08-27-20-39 uploaded (objtool: xen)

From: Peter Zijlstra <[email-masked]>
Date: Thu, 29 Aug 2019 10:24:45 +0200

On Wed, Aug 28, 2019 at 03:01:34PM -0500, Josh Poimboeuf wrote:
> On Wed, Aug 28, 2019 at 10:56:25AM -0700, Randy Dunlap wrote:
> > >> drivers/xen/gntdev.o: warning: objtool: gntdev_copy()+0x229: call to __ubsan_handle_out_of_bounds() with UACCESS enabled
> > > 
> > > Easy one :-)
> > > 
> > > diff --git a/tools/objtool/check.c b/tools/objtool/check.c
> > > index 0c8e17f946cd..6a935ab93149 100644
> > > --- a/tools/objtool/check.c
> > > +++ b/tools/objtool/check.c
> > > @@ -483,6 +483,7 @@ static const char *uaccess_safe_builtin[] = {
> > >  	"ubsan_type_mismatch_common",
> > >  	"__ubsan_handle_type_mismatch",
> > >  	"__ubsan_handle_type_mismatch_v1",
> > > +	"__ubsan_handle_out_of_bounds",
> > >  	/* misc */
> > >  	"csum_partial_copy_generic",
> > >  	"__memcpy_mcsafe",
> > > 
> > 
> > 
> > then I get this one:
> > 
> > lib/ubsan.o: warning: objtool: __ubsan_handle_out_of_bounds()+0x5d: call to ubsan_prologue() with UACCESS enabled
> 
> And of course I jinxed it by calling it easy.
> 
> Peter, how do you want to handle this?
> 
> Should we just disable UACCESS checking in lib/ubsan.c?

No, that is actually unsafe and could break things (as would you patch
above).

I'm thinking the below patch ought to cure things:

---
Subject: x86/uaccess: Don't leak the AC flags into __get_user() argument evalidation

Identical to __put_user(); the __get_user() argument evalution will too
leak UBSAN crud into the __uaccess_begin() / __uaccess_end() region.
While uncommon this was observed to happen for:

  drivers/xen/gntdev.c: if (__get_user(old_status, batch->status[i]))

where UBSAN added array bound checking.

This complements commit:

  6ae865615fc4 ("x86/uaccess: Dont leak the AC flag into __put_user() argument evaluation")

Reported-by: Randy Dunlap <[email-masked]>
Signed-off-by: Peter Zijlstra (Intel) <[email-masked]>
Cc: [email-masked]
---
 arch/x86/include/asm/uaccess.h | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

diff --git a/arch/x86/include/asm/uaccess.h b/arch/x86/include/asm/uaccess.h
index 9c4435307ff8..35c225ede0e4 100644
--- a/arch/x86/include/asm/uaccess.h
+++ b/arch/x86/include/asm/uaccess.h
@@ -444,8 +444,10 @@ __pu_label:							\
 ({									\
 	int __gu_err;							\
 	__inttype(*(ptr)) __gu_val;					\
+	__typeof__(ptr) __gu_ptr = (ptr);				\
+	__typeof__(size) __gu_size = (size);				\
 	__uaccess_begin_nospec();					\
-	__get_user_size(__gu_val, (ptr), (size), __gu_err, -EFAULT);	\
+	__get_user_size(__gu_val, __gu_ptr, __gu_size, __gu_err, -EFAULT);	\
 	__uaccess_end();						\
 	(x) = (__force __typeof__(*(ptr)))__gu_val;			\
 	__builtin_expect(__gu_err, 0);					\